import unittest
import sys

import context
from my2to3.hook import Finder


class TestHook(unittest.TestCase):
  def setUp(self):
    self._calls = []
    self._finder = None

  def transform(self, source, name, filename):
    self._calls.append((source, name, filename))
    return source

  def test_hook_sample(self):
    self._finder = Finder('sample', self.transform)
    sys.meta_path.append(self._finder)

    import sample.sample

    self.assertEqual(len(self._calls), 2)
    for i, s in enumerate((sample, sample.sample)):
      with open(s.__file__) as f:
        source = f.read()
      self.assertEqual(self._calls[i], (source, s.__name__, s.__file__))

    calls = self._calls
    self._calls = []

    reload(sample)
    reload(sample.sample)

    self.assertEqual(calls, self._calls)

  def tearDown(self):
    sys.meta_path.remove(self._finder)
    del sys.modules['sample']
    del sys.modules['sample.sample']
